using SciChart.Charting.ChartModifiers;
using SciChart.Charting.Visuals.RenderableSeries;
using SciChart.Drawing.Utility;
using SciChart.Drawing.Common;
using SciChart.Core;
using SciChart.Core.MarkupExtensions;
﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using SciChart.Charting.Model.DataSeries;

using SciChart.Charting.Model.DataSeries;

namespace WpfTestExample
{
    /// <summary>
    /// Класс для отображения разреза
    /// </summary>
    public class FontSizeTroubleDisplaySeries : FastLineRenderableSeries
    {
        public static readonly DependencyProperty CustomTextProperty = DependencyProperty.Register(
            "CustomText", typeof (string), typeof (FontSizeTroubleDisplaySeries), new PropertyMetadata(default(string)));

        public string CustomText
        {
            get { return (string) GetValue(CustomTextProperty); }
            set { SetValue(CustomTextProperty, value); }
        }

        /// <summary>
        /// Отрисовка разреза
        /// </summary>
        /// <param name="renderContext"></param>
        /// <param name="renderPassData"></param>
        protected override void InternalDraw(IRenderContext2D renderContext, IRenderPassData renderPassData)
        {
            base.InternalDraw(renderContext,renderPassData);
            DrawSimpleText(renderContext,DataSeries);
        }

        private void DrawSimpleText(IRenderContext2D renderContext, IDataSeries dataSeries)
        {
            var x = XAxis.GetCurrentCoordinateCalculator().GetCoordinate((double) dataSeries.XValues[1]);
            var y = YAxis.GetCurrentCoordinateCalculator().GetCoordinate((double) dataSeries.YValues[1]);
            renderContext.DrawText(new Rect(x, y, (float)FontSize * 15, (float)FontSize * 15), Stroke, (float)FontSize, CustomText);
        }

        internal static object GetInstanceField(Type type, object instance, string fieldName)
        {
            BindingFlags bindFlags = BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic
                | BindingFlags.Static;
            FieldInfo field = type.GetField(fieldName, bindFlags);
            return field.GetValue(instance);
        }
    }
}
